﻿namespace StockSharp.Plaza.Metadata
{
	/// <summary>
	/// Колонки таблицы, содержащей журнал сделок.
	/// Поток FORTS_FUTTRADE_REPL - таблица deal.
	/// </summary>
	public class PlazaDealFutureColumns : PlazaDealDerivativeColumns
	{
		internal PlazaDealFutureColumns()
			: base(PlazaTableId.DealFuture)
		{
			RepoId = new PlazaColumn(TableId, "id_repo", typeof(long));
		}

		/// <summary>
		/// Номер другой части сделки РЕПО.
		/// </summary>
		public readonly PlazaColumn RepoId;
	}
}