﻿namespace StockSharp.Plaza.Metadata
{
	/// <summary>
    /// Колонки таблицы, содержащей результаты клиринга: расчетные цены фьючерсов.
    /// Поток FORTS_CLR_REPL - таблица fut_sess_settl.
	/// </summary>
	public class PlazaSessionSettlementFutureColumns : PlazaSessionSettlementDerivativeColumns
	{
        internal PlazaSessionSettlementFutureColumns()
			: base(PlazaTableId.SessionSettlementFuture)
		{
            SettlementPrice = new PlazaColumn(TableId, "settl_price", "d16.5");
		}
        
		/// <summary>
        /// Расчетная цена.
		/// </summary>
        public readonly PlazaColumn SettlementPrice;
	}
}