﻿namespace StockSharp.Plaza.Metadata
{
	using System;
	using System.Collections.Generic;
	using System.IO;
	using System.Text;

	using Ecng.Common;
	using Ecng.Serialization;

	class PlazaTableSerializer : ISerializer
	{
		#region ISerializer Members

		public bool AllowNullableItems
		{
			get
			{
				throw new NotImplementedException();
			}
			set
			{
				throw new NotImplementedException();
			}
		}

		public void Deserialize(Stream stream, FieldCollection fields, SerializationItemCollection source)
		{
			throw new NotImplementedException();
		}

		public void Deserialize(Stream stream, SerializationItemCollection source)
		{
			throw new NotImplementedException();
		}

		public object Deserialize(SerializationItemCollection source, FieldCollection fields, object graph)
		{
			throw new NotImplementedException();
		}

		public object Deserialize(SerializationItemCollection source)
		{
			throw new NotImplementedException();
		}

		public object Deserialize(Stream stream, FieldCollection fields, object graph)
		{
			throw new NotImplementedException();
		}

		public object Deserialize(Stream stream)
		{
			//if (stream == null)
			//    throw new ArgumentNullException("stream");

			//TextReader textReader = new StreamReader(stream, true);
			//return Parse(textReader.ReadToEnd());
			throw new NotImplementedException();
		}

		public object Deserialize(string fileName)
		{
			//if (fileName.IsEmpty())
			//    throw new ArgumentException("fileName");

			//var text = File.ReadAllText(fileName, Encoding.GetEncoding("windows-1251"));
			//return Parse(text);
			throw new NotImplementedException();
		}

		public object Deserialize(byte[] data)
		{
			//if (data == null)
			//    throw new ArgumentNullException("data");

			//var text = Encoding.Unicode.GetString(data);
			//return Parse(text);
			throw new NotImplementedException();
		}

		public ISerializer GetSerializer(Type entityType)
		{
			throw new NotImplementedException();
		}

		public Serializer<T> GetSerializer<T>()
		{
			throw new NotImplementedException();
		}

		public IList<string> IgnoreFields
		{
			get { throw new NotImplementedException(); }
		}

		public Schema Schema
		{
			get { throw new NotImplementedException(); }
		}

		public void Serialize(SerializationItemCollection source, Stream stream)
		{
			throw new NotImplementedException();
		}

		public void Serialize(object graph, FieldCollection fields, SerializationItemCollection source)
		{
			throw new NotImplementedException();
		}

		public void Serialize(object graph, SerializationItemCollection source)
		{
			throw new NotImplementedException();
		}

		public void Serialize(object graph, FieldCollection fields, Stream stream)
		{
			throw new NotImplementedException();
		}

		public void Serialize(object graph, Stream stream)
		{
			if (stream == null)
				throw new ArgumentNullException("stream");

			stream.WriteRaw(Serialize(graph));
		}

		public void Serialize(object graph, string fileName)
		{
			if (fileName.IsEmpty())
				throw new ArgumentNullException("fileName");

			File.WriteAllText(fileName, CreateTableText(graph));
		}

		public byte[] Serialize(object graph)
		{
			return Encoding.Unicode.GetBytes(CreateTableText(graph));
		}

		public Type Type
		{
			get { throw new NotImplementedException(); }
		}

		public string FileExtension
		{
			get { throw new NotImplementedException(); }
		}

		public object GetId(object graph)
		{
			throw new NotImplementedException();
		}

		#endregion

		static string CreateTableText(object graph)
		{
			var table = graph as PlazaTable;
			if (table == null)
				throw new InvalidCastException("graph должен быть типом PlazaTable");

			var buffer = new StringBuilder();

			// Эта строчка нужна для инициализации потока в конструкторе PlazaStream
			buffer.AppendLine(";[stream:{0}]".Put(table.Id.StreamName));

			buffer.AppendLine("[dbscheme:{0}]".Put(table.ReplicationScheme));
			buffer.AppendLine("table={0}".Put(table.Id.TableName));
			buffer.AppendLine("[table:{0}:{1}]".Put(table.ReplicationScheme, table.Id.TableName));

			foreach (var column in table.Columns)
			{
				buffer.AppendLine("field={0},{1}".Put(column.Name, column.PlazaType));
			}

			// TO DO: Для базового клиента еще нужно указать индексы, для безбазового они не нужны.

			//System.Diagnostics.Trace.WriteLine(buffer.ToString());

			return buffer.ToString();
		}
	}
}